module CLOCK( CLK, CE, RST, SW1, SW2, O_MIN_H, O_MIN_L, O_HUR_H, O_HUR_L );

    input CLK, CE, RST, SW1, SW2;

	 output [3:0] O_MIN_H, O_MIN_L;
	 reg    [3:0] O_MIN_H, O_MIN_L;

	 output [3:0] O_HUR_H, O_HUR_L;
	 reg    [3:0] O_HUR_H, O_HUR_L;

	 reg CARRY1, CARRY2, CARRY3;

	// 0 -> 9
	always @( posedge CLK ) begin
		if( RST )
			O_MIN_L <= 0;
		else if( CE || SW1 ) begin
			if( O_MIN_L == 4'd9 ) begin
				O_MIN_L <= 0;
				CARRY1  <= 0;
			end
			else if( O_MIN_L == 4'd8 ) begin
				O_MIN_L <= O_MIN_L + 1'b1;
				CARRY1  <= 1;
			end 
			else begin
				O_MIN_L <= O_MIN_L + 1'b1;
				CARRY1  <= 0;
			end
		end
   end

	// 0 -> 6
	always @( posedge CLK ) begin
		if( RST )
			O_MIN_H <= 0;
		else if( (CE & CARRY1) || (SW1 & CARRY1) ) begin
			if( O_MIN_H == 4'd5 ) begin
				O_MIN_H <= 0;
				CARRY2  <= 0;
			end
			else if( O_MIN_H == 4'd4 ) begin
				O_MIN_H <= O_MIN_H + 1'b1;
				CARRY2 <= 1;
			end 
			else begin
				O_MIN_H <= O_MIN_H + 1'b1;
				CARRY2 <= 0;
			end
		end
   end

	// 0 -> 9
	always @( posedge CLK ) begin
		if( RST )
			O_HUR_L <= 0;
		else if( (CE & CARRY1 & CARRY2) || SW2 ) begin
			if( O_HUR_L == 4'd8 ) begin
				O_HUR_L <= O_HUR_L + 1'b1;
				CARRY3  <= 1;
			end
			else if( O_HUR_L == 4'd9 ) begin
				O_HUR_L <= 0;
				CARRY3  <= 0;
			end
			else if( O_HUR_L == 4'd3 && O_HUR_H == 4'd2 ) begin
				O_HUR_L <= 0;
				CARRY3  <= 0;
			end
			else if( O_HUR_L == 4'd2 && O_HUR_H == 4'd2 ) begin
				O_HUR_L <= O_HUR_L + 1'b1;
				CARRY3 <= 1;
			end 
			else begin
				O_HUR_L <= O_HUR_L + 1'b1;
				CARRY3 <= 0;
			end
		end
   end

	// 0 -> 2
	always @( posedge CLK ) begin
		if( RST )
			O_HUR_H <= 0;
		else if( CE & CARRY1 & CARRY2 & CARRY3 || (SW2 & CARRY3) ) begin
			if( O_HUR_H == 4'd2 )
				O_HUR_H <= 0;
			else if( O_HUR_H == 4'd1 )
				O_HUR_H <= O_HUR_H + 1'b1;
			else 
				O_HUR_H <= O_HUR_H + 1'b1;
		end
   end

endmodule
