module REM_CHAT( CLK, RST, DIN, DOUT );

input      CLK, RST, DIN;
output     DOUT;
reg        DOUT;
reg        CE;
reg [17:0] CNT;

parameter MAX_CNT = 18'd1843200;

always @( posedge CLK ) begin
 	if( RST ) begin
		CNT <= 0;
		CE  <= 0;
	end
	else if( CNT == MAX_CNT - 1'b1 ) begin
		CNT <= 0;
		CE  <= 1;
	end
	else begin
		CNT <= CNT + 1'b1;
		CE  <= 0;
	end
end

always @( posedge CLK ) begin
 	if( RST ) begin
		DOUT <= 0;
	end
	else if( CE == 1'b1 ) begin
		DOUT <= DIN;
	end
end

endmodule
