/***           */
/**  SEG_CNT  **/
/*           ***/
module SEG_CNT( CLK, RST, SEL );
	input         CLK, RST;
	output  [1:0] SEL;
	reg     [1:0] SEL;

	reg    [11:0] DIVCNT;
	reg           CE;

	parameter MAX_DIVCNT = 12'd4095;

	always @( posedge CLK ) begin
		if( RST )
			SEL <= 0;
		else if( CE )
			if( SEL == 2'h3 )
				SEL <= 2'h0;
			else
				SEL <= SEL + 1'b1;
	end

	always @( posedge CLK ) begin
		if( RST )
			DIVCNT <= 0;
		else if( DIVCNT == MAX_DIVCNT ) begin
			DIVCNT <= 0;
			CE <= 1;
		end
		else begin
			DIVCNT <= DIVCNT + 1'b1;
			CE <= 0;
		end
	end
			
endmodule
